10 CLEAR : KEY OFF : CLS : SCREEN 1,1 : CLS : OPTION BASE 1 : DEFINT A-Z
20 DEF SEG : POKE &H4E,1
30 DIM I(1),J(1),K(1),W(1),W1(1),W2(1)
40 DIM BIT(16)
50 DIM THREAD(130),TREADLE(24),LIFT1(76),LIFT2(76),PEG(76)
60 DIM IMAGE(8032)
70 '
80 '    This package uses medium resolution graphics, with the weave draft
90 ' displayed in a window 320 pixels wide and 190 pixels deep. The following
100 ' table describes pixel ranges for each field of the draft:
110 '
120 '   Field    X-window   Y-window         Co-ordinate Translation
130 ' ---------  -------    -------   ---------------------------------------
140 ' Threading   58:318    188:158   (1,1) at (58,188); (130,16) at (318,158)
150 ' Tie-up       2: 48    188:158   (1,1) at ( 2,188); ( 24,16) at ( 48,158)
160 ' Treadling    2: 48    150:  2   (1,1) at ( 2,150); ( 24,76) at ( 48,  2)
170 ' (Pattern)   58:318    150:  2     [Derived from other three fields.]
180 ' (Prompt)     0:319    192:199     [Message field; character display.]
190 '
200 ' Note that everything is left to right and bottom to top. This is
210 ' the method recommended by Clotidle Barret (Weaver's Journal, Vol 8
220 ' No. 1, issue 29, Summer 1983) for creating a standard weaving draft.
230 '
240 '
250 '   Program Initialization
260 '
270 FOR I = 1 TO 15
280 BIT(I) = 2^(I-1)
290 NEXT I
300 BIT(16) = &H8000
310 CMDSTR$ = CHR$(75)+CHR$(77)+CHR$(72)+CHR$(80)+CHR$(82)+CHR$(83)+CHR$(71)+CHR$(79)+CHR$(73)+CHR$(81)+CHR$(16)
320 CTHREAD = 1 : CTREADLE = 1 : CLIFT = 1
330 MAXTHREAD = 0 : MAXTREADLE = 0 : MAXPICK = 0
340 REGEN = 0
350 '   +---------------------------------------------------------------+
360 '   |               First Screen Display                            |
370 '   |                                                               |
380 '   | This section will display the initial program screen to the   |
390 '   | operator.  If the user wishes to bypass the initial           |
400 '   | display of instructions, s/he may do so by keying <return>    |
410 '   +---------------------------------------------------------------+
420 LOCATE 5,1
430 '      ....*....1....*....2....*....3....*....4
440 PRINT "            WEAVE-DRAFT 1.0"
450 PRINT
460 PRINT "  (C) Copyright 1983 Stephen Satchell"
470 PRINT "           All Rights Reserved"
480 PRINT
490 PRINT
500 PRINT
510 PRINT "  To bypass the operating instructions"
520 PRINT
530 PRINT "        key (return). Otherwise "
540 PRINT
550 PRINT "         depress the space bar."
560 PRINT
570 PRINT
580 PRINT "   For assistance, key ? at any time."
590 A$ = INKEY$ : IF A$ = "" GOTO 590
600 IF A$ = " " OR A$ = "?" THEN CLS : GOSUB 740 : GOTO 2960
610 IF A$ = CHR$(13) THEN CLS : GOTO 2960
620 BEEP : GOTO 590
630 '   +---------------------------------------------------------------+
640 '   |               Help Screen Subroutine                          |
650 '   |                                                               |
660 '   | This subroutine will display several screens in succession    |
670 '   | to describe how to run this program.  The command interpreter |
680 '   | will invoke this subroutine whenever the '?' key is           |
690 '   | depressed.                                                    |
700 '   |                                                               |
710 '   | First, the current screen image is saved, then the            |
720 '   | descriptions are printed, then the screen is restored.        |
730 '   +---------------------------------------------------------------+
740 GET (0,0)-(319,199),IMAGE
750 CLS
760 'rint "....*....1....*....2....*....3....*....4"
770 PRINT "            Topic Selection"
780 PRINT
790 PRINT "Key the item number for the topic"
800 PRINT "desired. For a full tutorial, key PgDn."
810 PRINT
820 PRINT "1   Overview"
830 PRINT "2   Keyboard Input -- Numeric Data"
840 PRINT "3   Keyboard Input -- Commands"
850 PRINT "4   Threading Field Entry"
860 PRINT "5   Tie-up Field Entry"
870 PRINT "6   Treadling (Weft Pick) Field Entry"
880 PRINT "7   Pattern Display"
890 PRINT "8   Program Termination"
900 LOCATE 24,1
910 PRINT "ESC -> return              PgDn -> next";
920 C$ = INKEY$ : IF C$="" GOTO 920
930 IF ASC(C$) = 27 THEN PUT(0,0),IMAGE,PSET : RETURN
940 IF C$ = CHR$(0)+CHR$(81) GOTO 970
950 ON INSTR("12345678",C$) GOTO 970,1230,1480,1790,2050,2310,2570,2760
960 GOSUB 7110 : GOTO 920
970 CLS
980 'rint "....*....1....*....2....*....3....*....4"
990 PRINT "                Overview"
1000 PRINT
1010 PRINT "WDRAFT is a weaving simulator that"
1020 PRINT "defines a standard pattern draft and"
1030 PRINT "then displays the resulting pattern."
1040 PRINT
1050 PRINT "The standard pattern draft consists of"
1060 PRINT "four fields: the threading, the tie-up,"
1070 PRINT "the treadling (picks), and the pattern."
1080 PRINT "You define the first three fields;"
1090 PRINT "WDRAFT will determine the resulting "
1100 PRINT "pattern and will display it to you."
1110 PRINT
1120 PRINT "As you enter the definition, WDRAFT"
1130 PRINT "will display the results. You may then"
1140 PRINT "return to any input field and change"
1150 PRINT "the definition, then watch as the new"
1160 PRINT "pattern emerges."
1170 LOCATE 24,1
1180 PRINT "ESC -> menu  PgUp -> menu  PgDn -> next";
1190 GOSUB 6740
1200 IF CMD = 11 OR CMD = 9 GOTO 750
1210 IF CMD = 10 GOTO 1230
1220 GOSUB 7110 : GOTO 1190
1230 CLS
1240 'rint "....*....1....*....2....*....3....*....4"
1250 PRINT "    Keyboard Input -- Numeric Data"
1260 PRINT
1270 PRINT "All numbers are input as either two"
1280 PRINT "digit numbers or a single digit followed"
1290 PRINT "by space, plus, comma or period."
1300 PRINT
1310 PRINT "When the first digit is keyed, it will"
1320 PRINT "be displayed in the status line. When"
1330 PRINT "the second digit or separater is keyed,"
1340 PRINT "the digit or a space will be displayed"
1350 PRINT "in the status line, and the number"
1360 PRINT "used."
1370 PRINT
1380 PRINT "If the first digit is keyed in error,"
1390 PRINT "the BACKSPACE key may be used to erase"
1400 PRINT "it."
1410 LOCATE 24,1
1420 PRINT "ESC -> Menu  PgUp -> prev  PgDn -> next";
1430 GOSUB 6740
1440 IF CMD = 11 GOTO 750
1450 IF CMD = 9 GOTO 970
1460 IF CMD = 10 GOTO 1480
1470 GOSUB 7110 : GOTO 1430
1480 CLS
1490 'rint "....*....1....*....2....*....3....*....4"
1500 PRINT "      Keyboard Input -- Commands"
1510 PRINT
1520 PRINT "All of the command keys except ESC and Q"
1530 PRINT "are on the keypad at the right side of"
1540 PRINT "the keyboard. "
1550 PRINT
1560 PRINT "The four arrow keys control the box"
1570 PRINT "cursor. Home will return to position 1,"
1580 PRINT "while END will point to the next open"
1590 PRINT "position."
1600 PRINT
1610 PRINT "INS will move definitions at and beyond"
1620 PRINT "the current position out and open an"
1630 PRINT "empty one. DEL will remove the current"
1640 PRINT "definition and close up the hole."
1650 PRINT
1660 PRINT "ESC permits all definitions in a field"
1670 PRINT "to be erased. "
1680 PRINT
1690 PRINT "PgUp and PgDn control movement between"
1700 PRINT "fields. 'Q' will terminate the program."
1710 PRINT "'?' will display these screens."
1720 PRINT
1730 PRINT "ESC -> menu  PgUp -> prev  PgDn -> next";
1740 GOSUB 6740
1750 IF CMD = 11 GOTO 750
1760 IF CMD = 9 GOTO 1230
1770 IF CMD = 10 GOTO 1790
1780 GOSUB 7110 : GOTO 1740
1790 CLS
1800 'rint "....*....1....*....2....*....3....*....4"
1810 PRINT "           Threading Field"
1820 PRINT
1830 PRINT "Each position corrosponds to a warp end."
1840 PRINT "Numeric input assigns an end to a shaft;"
1850 PRINT "this may range from 1 to 16. A new def-"
1860 PRINT "inition over-rides any existing one."
1870 PRINT
1880 PRINT "Cursor left, cursor right, HOME and END"
1890 PRINT "will move the box cursor."
1900 PRINT "INS permits a new thread to be inserted."
1910 PRINT "DEL will remove a thread."
1920 PRINT "ESC will erase all threads."
1930 PRINT
1940 PRINT "PgUp will display the info screens."
1950 PRINT "PgDn will enter tie-up field definition."
1960 PRINT
1970 PRINT "Q will terminate the program."
1980 LOCATE 24,1
1990 PRINT "ESC -> menu  PgUp -> prev  PgDn -> next";
2000 GOSUB 6740
2010 IF CMD = 11 GOTO 750
2020 IF CMD = 9 GOTO 1480
2030 IF CMD = 10 GOTO 2050
2040 GOSUB 7110 : GOTO 2000
2050 CLS
2060 'rint "....*....1....*....2....*....3....*....4"
2070 PRINT "             Tie-up Field"
2080 PRINT
2090 PRINT "To hook or unhook a shaft from the cur-"
2100 PRINT "rent treadle, key the two-digit shaft"
2110 PRINT "number. When a treadle has been defined,"
2115 PRINT "use the cursor keys to advance to the"
2116 PRINT "next treadle."
2120 PRINT
2130 PRINT "Cursor left, cursor right, HOME and END"
2140 PRINT "will move the box cursor."
2150 PRINT "INS permits a new treadle to be"
2160 PRINT "inserted."
2170 PRINT "DEL will remove a treadle."
2180 PRINT "ESC will erase all tie-ups."
2190 PRINT
2200 PRINT "PgUp will re-enter threading field."
2210 PRINT "PgDn will enter treadling field."
2220 PRINT
2230 PRINT "Q will terminate the program."
2240 LOCATE 24,1
2250 PRINT "ESC -> menu  PgUp -> prev  PgDn -> next";
2260 GOSUB 6740
2270 IF CMD = 11 GOTO 750
2280 IF CMD = 9 GOTO 1790
2290 IF CMD = 10 GOTO 2310
2300 GOSUB 7110 : GOTO 2260
2310 CLS
2320 'rint "....*....1....*....2....*....3....*....4"
2330 PRINT "            Treadling Mode"
2340 PRINT
2350 PRINT "To depress or release a treadle from"
2360 PRINT "the current weft pick, key the two-digit"
2370 PRINT "treadle number. When the pick is defined"
2373 PRINT "use the cursor keys to advance to the"
2376 PRINT "next pick in sequence."
2380 PRINT
2390 PRINT "Cursor up, cursor down, HOME and END"
2400 PRINT "will move the box cursor."
2410 PRINT "INS permits a new weft pick to be"
2420 PRINT "inserted."
2430 PRINT "DEL will remove a weft pick."
2440 PRINT "ESC will erase all picks."
2450 PRINT
2460 PRINT "PgUp will re-enter tie-up field."
2470 PRINT "PgDn will remove the box cursor."
2480 PRINT
2490 PRINT "Q will terminate the program."
2500 LOCATE 24,1
2510 PRINT "ESC -> menu  PgUp -> prev  PgDn -> next";
2520 GOSUB 6740
2530 IF CMD = 11 GOTO 750
2540 IF CMD = 9 GOTO 2050
2550 IF CMD = 10 GOTO 2570
2560 GOSUB 7110 : GOTO 2520
2570 CLS
2580 'rint "....*....1....*....2....*....3....*....4"
2590 PRINT "            Pattern Display"
2600 PRINT
2610 PRINT "All box cursors are removed from the"
2620 PRINT "screen, permitting the pattern to be"
2630 PRINT "inspected without interference."
2640 PRINT
2650 PRINT "PgDn will return the box cursor to the"
2660 PRINT "treadling field."
2670 PRINT
2680 PRINT "Q will terminate the program."
2690 LOCATE 24,1
2700 PRINT "ESC -> menu  PgUp -> prev  PgDn -> next";
2710 GOSUB 6740
2720 IF CMD = 11 GOTO 750
2730 IF CMD = 9 GOTO 2310
2740 IF CMD = 10 GOTO 2760
2750 GOSUB 7110 : GOTO 2710
2760 CLS
2770 'rint "....*....1....*....2....*....3....*....4"
2780 PRINT "        Program Termination"
2790 PRINT
2800 PRINT "When 'Q' is keyed as a command, the"
2810 PRINT "question 'Terminate program (N,Y) will"
2820 PRINT "appear in the status line. If it is not"
2830 PRINT "answered 'Y' the program will continue."
2840 PRINT
2850 PRINT "If it is answered 'Y' then the question"
2860 PRINT "'Return to DOS (Y,N)' is asked. If it"
2870 PRINT "is not anwered 'N', control will return"
2880 PRINT "to DOS; otherwise control returns to"
2890 PRINT "the BASIC interpreter."
2900 LOCATE 24,1
2910 PRINT "ESC -> menu  PgUp -> prev";
2920 GOSUB 6740
2930 IF CMD = 11 GOTO 750
2940 IF CMD = 9 GOTO 2570
2950 GOSUB 7110 : GOTO 2920
2960 '
2970 LINE (1,153)-(319,153),1 : LINE (52,1)-(52,189),1
2980 '          +-------------------------------------------------------+
2990 '          |  set up to enter threading definition                 |
3000 '          +-------------------------------------------------------+
3010 LOCATE 25,1 : PRINT "Enter threading";TAB(39);
3020 LOCATE 25,31 : PRINT USING "_[###_]";CTHREAD; : LOCATE 10,1
3030 X = CTHREAD*2+56
3040 LINE(X-1,157)-(X+1,189),1,B : LINE(X-1,151-MAXLIFT*2)-(X+1,151),1,B
3050 GOSUB 6550
3060 LINE(X-1,157)-(X+1,189),0,B : LINE(X-1,151-MAXLIFT*2)-(X+1,151),0,B
3070 ON CMD+1 GOTO 3090,3200,3250,3300,3350,3380,3500,3630,3670,3750,3790,3830,3960
3080 GOSUB 7110 : GOTO 3010
3090 '
3100 '                   cmd = 0 is data; process thread definition
3110 '
3120 IF VALUE > 16 THEN GOSUB 7110 : GOTO 3020
3130 W = BIT(VALUE)
3140 THREAD(CTHREAD) = W
3150 IF MAXTHREAD < CTHREAD THEN MAXTHREAD = CTHREAD
3160 LINE(X,158)-(X,188),0 : PSET(X,190-VALUE*2)
3170 IF CTHREAD < 130 THEN CTHREAD = CTHREAD+1 ELSE GOSUB 7110
3180 REGEN = 1
3190 GOTO 3020
3200 '
3210 '          cmd = 1 is left-arrow;  move thread definition left one.
3220 '
3230 IF CTHREAD < 2 THEN GOSUB 7110 : GOTO 3010
3240 CTHREAD = CTHREAD-1 : GOTO 3020
3250 '
3260 '          cmd = 2 is right-arrow; advance thread one position
3270 '
3280 IF CTHREAD >= 130 OR CTHREAD > MAXTHREAD THEN GOSUB 7110 : GOTO 3040
3290 CTHREAD = CTHREAD+1 : GOTO 3020
3300 '
3310 '          cmd = 3 is up-arrow; nonsense for threading mode.
3320 '
3330 GOSUB 7110 : GOTO 3040
3340 '
3350 '          cmd = 4 is down-arrow; nonsense for threading mode.
3360 '
3370 GOSUB 7110 : GOTO 3040
3380 '
3390 '          cmd = 5 is insert; open up the thread definition.
3400 '
3410 IF MAXTHREAD >= 130 OR CTHREAD >= MAXTHREAD THEN GOSUB 7110 : GOTO 3040
3420 REGEN = 1
3430 GET(X,1)-(MAXTHREAD*2+56,188),IMAGE
3440 PUT(X+2,1),IMAGE,PSET
3450 LINE(X,2)-(X,150),0 : LINE(X,158)-(X,188),0
3460 FOR I = MAXTHREAD TO CTHREAD STEP -1
3470 THREAD(I+1) = THREAD(I)
3480 NEXT I
3490 THREAD(CTHREAD) = 0 : MAXTHREAD = MAXTHREAD+1 : GOTO 3020
3500 '
3510 '          cmd = 6 is delete; remove the current thread definition.
3520 '
3530 IF MAXTHREAD < 1 OR CTHREAD > MAXTHREAD THEN GOSUB 7110 : GOTO 3040
3540 REGEN = 1
3550 GET(X+2,1)-(MAXTHREAD*2+56,188),IMAGE
3560 PUT(X,1),IMAGE,PSET
3570 LINE(MAXTHREAD*2+56,2)-(MAXTHREAD*2+56,150),0
3580 LINE(MAXTHREAD*2+56,158)-(MAXTHREAD*2+56,188),0
3590 FOR I = CTHREAD TO MAXTHREAD-1
3600 THREAD(I) = THREAD(I+1)
3610 NEXT I
3620 THREAD(MAXTHREAD) = 0 : MAXTHREAD = MAXTHREAD-1 : GOTO 3020
3630 '
3640 '          cmd = 7 is home; reset current thread to 1.
3650 '
3660 CTHREAD = 1 : GOTO 3020
3670 '
3680 '          cmd = 8 is end; set current thread beyond last thread.
3690 '
3700 IF MAXTHREAD < 130 THEN CTHREAD = MAXTHREAD+1 ELSE CTHREAD = MAXTHREAD
3710 GOTO 3020
3720 '
3730 '          cmd = 9 is page up; enter tie-up mode.
3740 '
3750 GOTO 3970
3760 '
3770 '          cmd = 10 is page dn; enter help mode, then threading.
3780 '
3790 GOSUB 740 : GOTO 3040
3800 '
3810 '          cmd = 11 is escape; currently not used.
3820 '
3830 LOCATE 25,1 : PRINT "Erase all threading? (N,Y)";TAB(39); : C$ = INPUT$(1)
3840 IF ASC(C$) <> 89 AND ASC(C$) <> 121 GOTO 3010
3850 '
3860 '          Delete all tie-ups.
3870 '
3880 FOR I = 1 TO MAXTHREAD
3890 THREAD(I) = 0
3900 NEXT I
3910 MAXTHREAD = 0 : CTHREAD = 1
3920 LINE(58,158)-(318,188),0,BF : LINE(58,2)-(318,150),0,BF
3930 GOTO 3010
3940 '          cmd = 12 is return; currently not used.
3950 '
3960 GOSUB 7110 : GOTO 3020
3970 '   +---------------------------------------------------------------+
3980 '   |  Tie-up editing.  Allow the user to key into the tie-up area  |
3990 '   |  as he/she/it wants to. Note that unlike the threading area   |
4000 '   |  each "treadle" may specify more than one shaft.  Therefore   |
4010 '   |  the cursor does not move until the user says to.  When       |
4020 '   |  specifying the tie-up, each shaft specification is a toggle; |
4030 '   |  if the treadle was not specified, it is added; if it had     |
4040 '   |  already been specified, it is removed.                       |
4050 '   +---------------------------------------------------------------+
4060 LOCATE 25,1 : PRINT "Enter tie-up";TAB(39);
4070 LOCATE 25,31 : PRINT USING "_[###_]";CTREADLE; : LOCATE 10,1
4080 X = CTREADLE*2
4090 LINE(X-1,157)-(X+1,189),1,B
4100 GOSUB 6740
4110 LINE(X-1,157)-(X+1,189),0,B
4120 ON CMD+1 GOTO 4140,4250,4290,4340,4390,4420,4540,4660,4700,4780,4820,4860,4990
4130 GOSUB 7110 : GOTO 4060
4140 '
4150 '   cmd = 0 is data; process treadle definition
4160 '
4170 IF VALUE > 16 THEN GOSUB 7110 : GOTO 4070
4180 REGEN = 1
4190 TREADLE(CTREADLE) = TREADLE(CTREADLE) XOR BIT(VALUE)
4200 IF TREADLE(CTREADLE) AND BIT(VALUE) THEN PSET(X,190-VALUE*2) ELSE PRESET(X,190-VALUE*2)
4210 IF TREADLE(CTREADLE) <> 0 AND MAXTREADLE < CTREADLE THEN MAXTREADLE = CTREADLE
4220 IF TREADLE(CTREADLE) = 0 AND MAXTREADLE = CTREADLE THEN MAXTREADLE = MAXTREADLE-1
4230 GOTO 4070
4240 '
4250 '          cmd = 1 is left-arrow;  move treadle definition left one.
4260 '
4270 IF CTREADLE < 2 THEN GOSUB 7110 : GOTO 4090
4280 CTREADLE = CTREADLE-1 : GOTO 4070
4290 '
4300 '          cmd = 2 is right-arrow; advance treadle one position
4310 '
4320 IF CTREADLE >= 24 OR CTREADLE > MAXTREADLE THEN GOSUB 7110 : GOTO 4090
4330 CTREADLE = CTREADLE+1 : GOTO 4070
4340 '
4350 '          cmd = 3 is up-arrow; nonsense in tie-up mode.
4360 '
4370 GOSUB 7110 : GOTO 4070
4380 '
4390 '          cmd = 4 is down-arrow; nonsense in tie-up mode.
4400 '
4410 GOSUB 7110 : GOTO 4070
4420 '
4430 '          cmd = 5 is insert; open up the treadle definition.
4440 '
4450 IF MAXTREADLE >= 24 OR CTREADLE > MAXTREADLE THEN GOSUB 7110 : GOTO 4090
4460 REGEN = 1
4470 GET(X,158)-(MAXTREADLE*2,188),IMAGE
4480 PUT(X+2,158),IMAGE,PSET
4490 LINE (X,158)-(X,188),0
4500 FOR I = MAXTREADLE TO CTREADLE STEP -1
4510 TREADLE(I+1) = TREADLE(I)
4520 NEXT I
4530 TREADLE(CTREADLE) = 0 : MAXTREADLE = MAXTREADLE+1 : GOTO 4070
4540 '
4550 '          cmd = 6 is delete; remove the current tie-up definition.
4560 '
4570 IF MAXTREADLE < 1 OR CTREADLE > MAXTREADLE THEN GOSUB 7110 : GOTO 4090
4580 REGEN = 1
4590 GET (X+2,158)-(MAXTREADLE*2,188),IMAGE
4600 PUT (X,158),IMAGE,PSET
4610 LINE(MAXTREADLE*2,158)-(MAXTREADLE*2,188),0
4620 FOR I = CTREADLE TO MAXTREADLE-1
4630 TREADLE(I) = TREADLE(I+1)
4640 NEXT I
4650 TREADLE(MAXTREADLE) = 0 : MAXTREADLE = MAXTREADLE-1 : GOTO 4070
4660 '
4670 '          cmd = 7 is home; reset current treadle to 1.
4680 '
4690 CTREADLE = 1 : GOTO 4070
4700 '
4710 '          cmd = 8 is end; set current thread beyond last thread.
4720 '
4730 IF MAXTREADLE < 24 THEN CTREADLE = MAXTREADLE+1 ELSE CTREADLE = MAXTREADLE
4740 GOTO 4070
4750 '
4760 '          cmd = 9 is page up; go to threadling mode.
4770 '
4780 GOTO 5090
4790 '
4800 '          cmd = 10 is page down; back to threading mode.
4810 '
4820 GOTO 3010
4830 '
4840 '          cmd = 11 is escape; currently not used.
4850 '
4860 LOCATE 25,1 : PRINT "Erase all tie-ups? (N,Y)";TAB(39); : C$ = INPUT$(1)
4870 IF ASC(C$) <> 89 AND ASC(C$) <> 121 GOTO 4060
4880 '
4890 '          Delete all tie-ups.
4900 '
4910 FOR I = 1 TO MAXTREADLE
4920 TREADLE(I) = 0
4930 NEXT I
4940 MAXTREADLE = 0 : CTREADLE = 1
4950 LINE(2,158)-(48,188),0,BF
4960 GOTO 4060
4970 '          cmd = 12 is return; currently not used.
4980 '
4990 GOSUB 7110 : GOTO 4070
5000 '   +---------------------------------------------------------------+
5010 '   |  Lift editing.  Allow the user to key into the lift area      |
5020 '   |  as he/she/it wants to. Note that like the tie-up area        |
5030 '   |  each "lift" may specify more than one treadle.  Therefore    |
5040 '   |  the cursor does not move until the user says to.  When       |
5050 '   |  specifying the lifts, each treadle specification is a toggle;|
5060 '   |  if the shaft(s) were not lifted, it is added, but if it has  |
5070 '   |  already been specified, it is removed.                       |
5080 '   +---------------------------------------------------------------+
5090 IF MAXLIFT = 0 OR REGEN = 0 GOTO 5420
5100 REGEN = 0
5110 LOCATE 25,1 : PRINT "Regenerating pattern.";TAB(39);
5120 FOR GLIFT = 1 TO MAXLIFT : GOSUB 5300 : GOSUB 5180
5130 LOCATE 25,31 : PRINT USING "_[###_]";GLIFT; : NEXT GLIFT
5140 GOTO 5420
5150 '
5160 '     Subroutine to generate draft for the current treadle line.
5170 '
5180 Y = 152-GLIFT*2 : CPEG = PEG(GLIFT)
5190 FOR K = 1 TO 16
5200 IF CPEG AND BIT(K) THEN GET(58,190-K*2)-(318,190-K*2),IMAGE : PUT(58,Y),IMAGE,PSET : GOTO 5230
5210 NEXT K
5220 LINE(58,Y)-(318,Y),0 : GOTO 5260
5230 FOR K = K TO 16
5240 IF CPEG AND BIT(K) THEN GET(58,190-K*2)-(318,190-K*2),IMAGE : PUT(58,Y),IMAGE,OR
5250 NEXT K
5260 RETURN
5270 '
5280 '         Subroutine to generate peg from treadle and tie-up.
5290 '
5300 CPEG = 0 : CLIFT1 = LIFT1(GLIFT) : CLIFT2 = LIFT2(GLIFT)
5310 FOR K = 1 TO 8
5320 IF CLIFT1 AND BIT(K) THEN CPEG = CPEG OR TREADLE(K)
5330 IF CLIFT2 AND BIT(K) THEN CPEG = CPEG OR TREADLE(K+16)
5340 NEXT K
5350 FOR K = 9 TO 16
5360 IF CLIFT1 AND BIT(K) THEN CPEG = CPEG OR TREADLE(K)
5370 NEXT K
5380 PEG(GLIFT) = CPEG : RETURN
5390 '
5400 '     Entry for treadling processing.
5410 '
5420 LOCATE 25,1 : PRINT "Enter treadling sequence.";TAB(39);
5430 '
5440 '     re-entry point.
5450 '
5460 LOCATE 25,31 : PRINT USING "_[###_]";CLIFT; : LOCATE 10,1
5470 Y = 152-CLIFT*2
5480 LINE(1,Y-1)-(49,Y+1),1,B : LINE(57,Y-1)-(319,Y+1),1,B
5490 GOSUB 6740
5500 LINE(1,Y-1)-(49,Y+1),0,B : LINE(57,Y-1)-(319,Y+1),0,B
5510 ON CMD+1 GOTO 5560,5680,5720,5760,5810,5860,5980,6110,6150,6200,6240,6280,6420
5520 GOSUB 7110 : GOTO 5420
5530 '
5540 '   cmd = 0 is data; process lift definition
5550 '
5560 CLIFT1 = LIFT1(CLIFT) : CLIFT2 = LIFT2(CLIFT)
5570 X = VALUE*2
5580 IF VALUE < 17 THEN CLIFT1 = CLIFT1 XOR BIT(VALUE) : IF CLIFT1 AND BIT(VALUE) THEN PSET(X,Y) ELSE PRESET(X,Y)
5590 IF VALUE > 16 AND VALUE < 25 THEN CLIFT2 = CLIFT2 XOR BIT(VALUE-16) : IF CLIFT2 AND BIT(VALUE-16) THEN PSET(X,Y) ELSE PRESET(X,Y)
5600 IF VALUE > 24 THEN GOSUB 7110 : GOTO 5460
5610 IF (CLIFT1 OR CLIFT2) <>  0 AND MAXLIFT < CLIFT THEN MAXLIFT = CLIFT
5620 IF (CLIFT1 OR CLIFT2) =  0 AND MAXLIFT = CLIFT THEN MAXLIFT = MAXLIFT-1
5630 LIFT1(CLIFT) = CLIFT1 : LIFT2(CLIFT) = CLIFT2
5640 GLIFT = CLIFT : GOSUB 5300 : GOSUB 5180 : GOTO 5460
5650 '
5660 '   cmd = 1 is left-arrow;  nonsense in this mode.
5670 '
5680 GOSUB 7110 : GOTO 5460
5690 '
5700 '   cmd = 2 is right-arrow; nonsense in this mode.
5710 '
5720 GOSUB 7110 : GOTO 5460
5730 '
5740 '   cmd = 3 is up-arrow; advnace one pick.
5750 '
5760 IF CLIFT >= 76 OR CLIFT > MAXLIFT THEN GOSUB 7110 : GOTO 5460
5770 CLIFT = CLIFT+1 : GOTO 5460
5780 '
5790 '   cmd = 4 is down-arrow; back up one pick.
5800 '
5810 IF CLIFT < 2 THEN GOSUB 7110 : GOTO 5460
5820 CLIFT = CLIFT-1 : GOTO 5460
5830 '
5840 '   cmd = 5 is insert; open up the lift definition.
5850 '
5860 IF MAXLIFT >= 76 OR CLIFT > MAXLIFT THEN GOSUB 7110 : GOTO 5460
5870 GET (2,152-MAXLIFT*2)-(318,Y),IMAGE
5880 PUT (2,150-MAXLIFT*2),IMAGE,PSET
5890 LINE(2,Y)-(48,Y),0 : LINE(58,Y)-(318,Y),0
5900 FOR I = MAXLIFT TO CLIFT STEP -1
5910 LIFT1(I+1) = LIFT1(I) : LIFT2(I+1) = LIFT2(I) : PEG(I+1) = PEG(I)
5920 NEXT I
5930 LIFT1(CLIFT) = 0 : LIFT2(CLIFT) = 0 : PEG(CLIFT) = 0
5940 MAXLIFT = MAXLIFT+1 : GOTO 5460
5950 '
5960 '   cmd = 6 is delete; remove the current treadle definition.
5970 '
5980 IF MAXLIFT < 1 OR CLIFT > MAXLIFT THEN GOSUB 7110 : GOTO 5460
5990 IF CLIST <> MAXLIFT THEN GET (2,152-MAXLIFT*2)-(318,Y-2),IMAGE
6000 LINE(2,152-MAXLIFT*2)-(48,152-MAXLIFT*2),0 : LINE(58,152-MAXLIFT*2)-(318,152-MAXLIFT*2),0
6010 IF CLIFT <> MAXLIFT THEN PUT (2,152-MAXLIFT*2+2),IMAGE,PSET
6020 FOR I = CLIFT TO MAXLIFT-1
6030 LIFT1(I) = LIFT1(I+1) : LIFT2(I) = LIFT2(I+1) : PEG(I) = PEG (I+1)
6040 NEXT I
6050 LIFT1(MAXLIFT) = 0 : LIFT2(MAXLIFT) = 0 : PEG(MAXLIFT) = 0
6060 MAXLIFT = MAXLIFT-1
6070 GOTO 5460
6080 '
6090 '   cmd = 7 is home; reset current treadle to 1.
6100 '
6110 CLIFT = 1 : GOTO 5460
6120 '
6130 '   cmd = 8 is end; set current treadle beyond last lift.
6140 '
6150 IF MAXLIFT < 76 THEN CLIFT = MAXLIFT + 1 ELSE CLIFT = MAXLIFT
6160 GOTO 5460
6170 '
6180 '   cmd = 9 is page up; enter display mode.
6190 '
6200 GOTO 6430
6210 '
6220 '   cmd = 10 is page down; go back to tie-up mode.
6230 '
6240 GOTO 4060
6250 '
6260 '   cmd = 11 is escape; purge lift definitions.
6270 '
6280 LOCATE 25,1 : PRINT "Erase all treadling? (N,Y)";TAB(39); : C$ = INPUT$(1)
6290 IF ASC(C$) <> 89 AND ASC(C$) <> 121 GOTO 5420
6300 '
6310 '          Delete all lifts.
6320 '
6330 FOR I = 1 TO MAXLIFT
6340 LIFT1(I) = 0 : LIFT2(I) = 0 : PEG(I) = 0
6350 NEXT I
6360 MAXLIFT = 0 : CLIFT = 1 : OLDLIFT = 1
6370 LINE (2,2)-(48,150),0,BF : LINE(58,2)-(318,150),0,BF
6380 GOTO 5090
6390 '
6400 '   cmd = 12 is return; currently not used.
6410 '
6420 GOSUB 7110 : GOTO 5460
6430 '
6440 ' +------------------------------------------------+
6450 ' |                Display Mode                    |
6460 ' |                                                |
6470 ' | Wait here in this mode for a PgDn command.     |
6480 ' | This mode permits the user to view the pattern |
6490 ' | without extra stuff on the screen.             |
6500 ' +------------------------------------------------+
6510 LOCATE 25,1 : PRINT "Pattern Display";TAB(39);
6520 GOSUB 6740
6530 IF CMD = 10 GOTO 5420
6540 GOSUB 7110: GOTO 6510
6550 '
6560 '    +-----------------------------------------------------------+
6570 '    |               Input Character Subroutine                  |
6580 '    |                                                           |
6590 '    | This subroutine will accept a keyboard character and de-  |
6600 '    | termine the type of character input.  If the input char-  |
6610 '    | acter is a digit pair, return command type zero,          |
6620 '    | and the character interpretation in "VALUE".  if the      |
6630 '    | keyboard character is a command key, return the command   |
6640 '    | code according to the following table :                   |
6650 '    |                                                           |
6660 '    | CMD= 1  Left arrow          CMD= 7  Home                  |
6670 '    |      2  Right arrow              8  End                   |
6680 '    |      3  Up arrow                 9  Page up               |
6690 '    |      4  Down arrow              10  Page down             |
6700 '    |      5  Insert                  11  Esc (Escape)          |
6710 '    |      6  Delete                  12  <--' (Return)         |
6720 '    |                                                           |
6730 '    +-----------------------------------------------------------+
6740 LOCATE 25,37 : PRINT CHR$(22);CHR$(22); : LOCATE 25,37
6750 C$ = INKEY$ : IF C$ = "" GOTO 6740
6760 IF LEN(C$) > 1 GOTO 7040
6770 '
6780 '  The first digit of a digit pair. Save the first digit and
6790 ' wait for the second digit. If the second keystroke is a
6800 ' digit, then multiply the first by 10 and add the second, then
6810 ' return the whole value in VALUE. If the second keystroke is
6820 ' a space, plus, comma, or period, then return the first value
6830 ' in VALUE. Otherwise beep the beeper and start again.
6840 '
6850 VALUE = ASC(C$)
6860 IF VALUE = 81 OR VALUE = 113 GOTO 7170
6870 IF VALUE = 63 THEN GOSUB 740 : GOTO 6740
6880 IF VALUE = 13 THEN CMD = 12 : RETURN
6890 IF VALUE = 27 THEN CMD = 11 : RETURN
6900 IF VALUE < 48 OR VALUE > 57 THEN GOSUB 7110 : GOTO 6740
6910 VALUE = VALUE - 48
6920 PRINT CHR$(VALUE+48);
6930 C$ = INKEY$ : IF C$="" GOTO 6930
6940 IF LEN(C$)>1 THEN GOSUB 7110 : GOTO 6740
6950 IF ASC(C$) = 8 GOTO 6740
6960 IF INSTR(" +,.",C$)>0 THEN PRINT " "; : GOTO 6990
6970 IF (C$ < "0" OR C$ > "9") THEN GOSUB 7110 : GOTO 6740
6980 VALUE = VALUE * 10 + (ASC(C$) - 48)
6990 IF VALUE = 0 THEN GOSUB 7110 : GOTO 6740
7000 PRINT C$;
7010 CMD = 0 : RETURN
7020 RETURN
7030 '
7040 IF ASC(C$) <>  0 THEN GOSUB 7110 : GOTO 6740
7050 CMD = INSTR(CMDSTR$,MID$(C$,2,1)) : IF CMD = 0 THEN GOSUB 7110 : GOTO 6740
7060 IF CMD > 10 THEN CLS : WIDTH 80 : SCREEN 0,0,0 :END
7070 RETURN
7080 '
7090 '  beep subroutine
7100 '
7110 BEEP
7120 C$ = INKEY$ : IF LEN(C$) <> 0 GOTO 7120
7130 RETURN
7140 '
7150 '  Program termination.
7160 '
7170 LOCATE 25,1 : PRINT "Terminate the Program? (N,Y)";TAB(39);
7180 C$ = INKEY$ : IF C$ = "" GOTO 7180
7190 LOCATE 25,1 : PRINT TAB(39);
7200 IF C$ <> "Y" AND C$ <> "y" THEN CMD = 99 : RETURN
7210 LOCATE 25,1 : PRINT "Return to DOS? (Y,N)";TAB(39);
7220 C$ = INKEY$ : IF C$ = "" GOTO 7220
7230 WIDTH 80 : SCREEN 0,0,0 : CLS
7240 IF C$ <> "N" AND C$ <> "n" THEN SYSTEM
7250 END
